﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	'
	Private URL_REQUEST As String = "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?unit=c&lang=en-us"	'ignore
	Private btnRequest As B4XView
	Private pnWeatherForecast As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	btnRequest_Click
End Sub

Private Sub btnRequest_Click
	'Request not used
	'RequestWeather(URL_REQUEST)
	'Update the weather data with test data provided from https://www.b4x.com/android/forum/threads/help-in-parsing-weather-json-and-showing-it-on-label.142269/
	UpdateWeatherData(SetTestData)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub RequestWeather(URL As String)	'ignore
	Dim job As HttpJob
	Log($"RequestWeather: ${URL}"$)
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download(URL)
	Wait For (job) JobDone(job As HttpJob)
	If job.Success Then
		UpdateWeatherData(job.GetString)
	Else
		Log(job.ErrorMessage)
	End If
	job.Release
	Log($"RequestWeather: done"$)
End Sub

Private Sub UpdateWeatherData(data As String)
	Log($"UpdateWeatherData"$)
	Dim DayNr As Int = 1
	Dim parser As JSONParser
	parser.Initialize(data)
	Dim jRoot As Map = parser.NextObject
	Dim Headline As Map = jRoot.Get("Headline")
	Dim Category As String = Headline.Get("Category")	'ignore
	Dim EndEpochDate As Int = Headline.Get("EndEpochDate")	'ignore
	Dim EffectiveEpochDate As Int = Headline.Get("EffectiveEpochDate")	'ignore
	Dim Severity As Int = Headline.Get("Severity")	'ignore
	Dim Text As String = Headline.Get("Text")	'ignore
	Dim EndDate As String = Headline.Get("EndDate")	'ignore
	Dim Link As String = Headline.Get("Link")	'ignore
	Dim EffectiveDate As String = Headline.Get("EffectiveDate")	'ignore
	Dim MobileLink As String = Headline.Get("MobileLink")	'ignore
	Dim DailyForecasts As List = jRoot.Get("DailyForecasts")
	For Each colDailyForecasts As Map In DailyForecasts
		Dim Temperature As Map = colDailyForecasts.Get("Temperature")
		Dim Minimum As Map = Temperature.Get("Minimum")
		Dim MinimumUnitType As Int = Minimum.Get("UnitType")	'ignore
		Dim MinimumValue As Double = Minimum.Get("Value")
		Dim MinimumUnit As String = Minimum.Get("Unit")	'ignore
		Dim Maximum As Map = Temperature.Get("Maximum")
		Dim MaximumUnitType As Int = Maximum.Get("UnitType")	'ignore
		Dim MaximumValue As Double = Maximum.Get("Value")
		Dim MaximumUnit As String = Maximum.Get("Unit")	'ignore
		Dim Night As Map = colDailyForecasts.Get("Night")
		Dim HasPrecipitation As String = Night.Get("HasPrecipitation")	'ignore
		Dim NightIconPhrase As String = Night.Get("IconPhrase")	'ignore
		Dim NightIconNr As Int = Night.Get("Icon")	'ignore
		Dim EpochDate As Int = colDailyForecasts.Get("EpochDate")	'ignore
		Dim Day As Map = colDailyForecasts.Get("Day")
		Dim DayHasPrecipitation As String = Day.Get("HasPrecipitation")	'ignore
		Dim DayIconPhrase As String = Day.Get("IconPhrase")
		Dim DayIconNr As Int = Day.Get("Icon")
		Dim Sources As List = colDailyForecasts.Get("Sources")
		For Each colSources As String In Sources
		Next
		Dim Date As String = colDailyForecasts.Get("Date")	'ignore
		Dim Link As String = colDailyForecasts.Get("Link")	'ignore
		Dim MobileLink As String = colDailyForecasts.Get("MobileLink")	'ignore
		'
		AddDay(DayNr, EpochDate, DayIconNr, DayIconPhrase, MinimumValue, MaximumValue)
		DayNr = DayNr + 1
	Next
End Sub

Private Sub AddDay(daynr As Int, EpochDate As Int, iconnr As Int, DayIconPhrase As String, tempmin As Int, tempmax As Int)
	Dim viewwidth As Int = Round(pnWeatherForecast.Width / 5)
	Dim lbldayofweekname As Label
	Dim iconimage As ImageView
	Dim lbltempminax As Label

	Dim DateTicks As Long = DateUtils.UnixTimeToTicks(EpochDate)
	DateUtils.GetDayOfWeekName(DateTicks)
	
	lbldayofweekname.Initialize("")
	lbldayofweekname.Text = $"${DateTime.Date(DateTicks)}${CRLF}${DateUtils.GetDayOfWeekName(DateTicks)}${CRLF}${DayIconPhrase}"$
	lbldayofweekname.WrapText = True
	lbldayofweekname.Alignment = "TOP_LEFT"
	pnWeatherForecast.AddView(lbldayofweekname, ((daynr - 1) * viewwidth) + 5, 10, viewwidth, 90)

	Dim IconLink As String = IIf(iconnr < 10, $"https://developer.accuweather.com/sites/default/files/0${iconnr}-s.png"$, $"https://developer.accuweather.com/sites/default/files/${iconnr}-s.png"$)
	'Log(IconLink)
	Dim job As HttpJob
	job.Initialize("", Me) 'note that the name parameter is no longer needed.
	job.Download(IconLink)
	Wait For (job) JobDone(job As HttpJob)
	If job.Success Then
		iconimage.Initialize("")
		iconimage.SetImage (job.GetBitmap)
	Else
	End If
	job.Release
	pnWeatherForecast.AddView(iconimage, ((daynr - 1) * viewwidth) + 5, 100, 75, 45)

	lbltempminax.Initialize("")
	lbltempminax.text = $"${tempmin} - ${tempmax}"$
	lbltempminax.Alignment = "CENTER_LEFT"
	pnWeatherForecast.AddView(lbltempminax, ((daynr - 1) * viewwidth) + 5, 160, viewwidth, 30)

	Log($"${DateTime.Date(DateTicks)} ${DateUtils.GetDayOfWeekName(DateTicks)}: min=${tempmin}, max=${tempmax}, ${DayIconPhrase}, ${iconnr}"$)
End Sub

Private Sub SetTestData As String
	Dim data As String = $"{
    "Headline": {
        "EffectiveDate": "2022-08-15T08:00:00+02:00",
        "EffectiveEpochDate": 1660543200,
        "Severity": 5,
        "Text": "A thunderstorm Monday",
        "Category": "thunderstorm",
        "EndDate": "2022-08-15T20:00:00+02:00",
        "EndEpochDate": 1660586400,
        "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?unit=c&lang=en-us",
        "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?unit=c&lang=en-us"
    },
    "DailyForecasts": [
        {
            "Date": "2022-08-11T07:00:00+02:00",
            "EpochDate": 1660194000,
            "Temperature": {
                "Minimum": {
                    "Value": 16.1,
                    "Unit": "C",
                    "UnitType": 17
                },
                "Maximum": {
                    "Value": 28.1,
                    "Unit": "C",
                    "UnitType": 17
                }
            },
            "Day": {
                "Icon": 2,
                "IconPhrase": "Mostly sunny",
                "HasPrecipitation": false
            },
            "Night": {
                "Icon": 33,
                "IconPhrase": "Clear",
                "HasPrecipitation": false
            },
            "Sources": [
                "AccuWeather"
            ],
            "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=1&unit=c&lang=en-us",
            "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=1&unit=c&lang=en-us"
        },
        {
            "Date": "2022-08-12T07:00:00+02:00",
            "EpochDate": 1660280400,
            "Temperature": {
                "Minimum": {
                    "Value": 17.5,
                    "Unit": "C",
                    "UnitType": 17
                },
                "Maximum": {
                    "Value": 28.3,
                    "Unit": "C",
                    "UnitType": 17
                }
            },
            "Day": {
                "Icon": 1,
                "IconPhrase": "Sunny",
                "HasPrecipitation": false
            },
            "Night": {
                "Icon": 33,
                "IconPhrase": "Clear",
                "HasPrecipitation": false
            },
            "Sources": [
                "AccuWeather"
            ],
            "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=2&unit=c&lang=en-us",
            "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=2&unit=c&lang=en-us"
        },
        {
            "Date": "2022-08-13T07:00:00+02:00",
            "EpochDate": 1660366800,
            "Temperature": {
                "Minimum": {
                    "Value": 18.3,
                    "Unit": "C",
                    "UnitType": 17
                },
                "Maximum": {
                    "Value": 28.1,
                    "Unit": "C",
                    "UnitType": 17
                }
            },
            "Day": {
                "Icon": 2,
                "IconPhrase": "Mostly sunny",
                "HasPrecipitation": false
            },
            "Night": {
                "Icon": 33,
                "IconPhrase": "Clear",
                "HasPrecipitation": false
            },
            "Sources": [
                "AccuWeather"
            ],
            "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=3&unit=c&lang=en-us",
            "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=3&unit=c&lang=en-us"
        },
        {
            "Date": "2022-08-14T07:00:00+02:00",
            "EpochDate": 1660453200,
            "Temperature": {
                "Minimum": {
                    "Value": 19.9,
                    "Unit": "C",
                    "UnitType": 17
                },
                "Maximum": {
                    "Value": 29.3,
                    "Unit": "C",
                    "UnitType": 17
                }
            },
            "Day": {
                "Icon": 3,
                "IconPhrase": "Partly sunny",
                "HasPrecipitation": false
            },
            "Night": {
                "Icon": 36,
                "IconPhrase": "Intermittent clouds",
                "HasPrecipitation": false
            },
            "Sources": [
                "AccuWeather"
            ],
            "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=4&unit=c&lang=en-us",
            "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=4&unit=c&lang=en-us"
        },
        {
            "Date": "2022-08-15T07:00:00+02:00",
            "EpochDate": 1660539600,
            "Temperature": {
                "Minimum": {
                    "Value": 16.6,
                    "Unit": "C",
                    "UnitType": 17
                },
                "Maximum": {
                    "Value": 23.9,
                    "Unit": "C",
                    "UnitType": 17
                }
            },
            "Day": {
                "Icon": 4,
                "IconPhrase": "Intermittent clouds",
                "HasPrecipitation": true,
                "PrecipitationType": "Rain",
                "PrecipitationIntensity": "Moderate"
            },
            "Night": {
                "Icon": 35,
                "IconPhrase": "Partly cloudy",
                "HasPrecipitation": false
            },
            "Sources": [
                "AccuWeather"
            ],
            "MobileLink": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=5&unit=c&lang=en-us",
            "Link": "http://www.accuweather.com/en/de/hemer/58675/daily-weather-forecast/174476?day=5&unit=c&lang=en-us"
        }
    ]
}"$
	return data
End Sub
